<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>MQTT Topics</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		html {
			visibility: hidden;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container">
		<div class="row">
			<main role="main" class="col-sm-12 col-md-12 col-lg-12 p-2">
				<div class="row pb-2">
					<h5 class="p-1 ml-3 mb-0">MQTT Topics available for this device</h5>
					<div id="loader_main" class="meti_loader m-1" style="width:1.5rem; height:1.5rem"></div>
					<button type="button" id="button_security" class="btn btn-sm btn-success ml-4 mr-4 p-1"
						value=0>Topic with
						password</button>
				</div>

				<div class="border border-primary p-2">
					<div class="row mt-2">
						<div class="col-md-10" id="mqtt_topics">
							<div class="col">
								<ol id="topic_list">
									<!-- <li class="font-weight-bold">Temp1</li>
							<ul>
								<li>ABCDEFG123567/getData/Channel1</li>
							</ul> -->
								</ol>
							</div>
						</div>
					</div>
				</div>
			</main>
		</div>
</body>
</html>

<script>
	w3IncludeHTML();
	$(document).ready(function () {
		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";
		$("#loader_main").css("display", "block");

		var sensor_list;

		$("#button_security").on("click", function () {
			btn = $(this).val();
			if (btn == 0) {
				$(this).html('Topic without password')
					.removeClass('btn-success')
					.addClass('btn-danger')
					.val(1)
			} else {
				$(this).html('Topic with password')
					.removeClass('btn-danger')
					.addClass('btn-success')
					.val(0)
			}
			list_sensor_topics();
		});

		function load_form_data() {
			//None
		}

		function list_sensor_topics() {
			//get the vendor names
			var topic_list = $('#topic_list');

			//clear topics first
			topic_list.html('');

			$.each(sensor_list, function (idx, val) {
				//topic heading, sensor name
				sensor_name_clean = getCleanString(val.sensor_name);

				var uom = '';

				if (val.unit_of_measure.length <= 1) {
					uom = '';
				} else {
					uom = "  (" + val.unit_of_measure + ")";
				}

				var topic_head_li = $('<li></li>')
					.addClass("font-weight-bold p-1 text-info")
					.html(val.sensor_name + ' ' + uom)

				// Narayan - this has to come from other screen
				var topic_pw = 'test_pw';

				if ($('#button_security').val() == 0) {
					topic_pw = '';
				} else {
					topic_pw = '/' + topic_pw;
				}

				//Narayan - This is only for this TH version
				//This should be removed for next rev
				if (idx == 'sensor_101') {
					sensor_name_clean = 'temperature'
				} else if (idx == 'sensor_102') {
					sensor_name_clean = 'humidity'
				}
				
				html_li = device_id
					+ topic_pw
					+ '/get'
					+ '/' + sensor_name_clean

				var copy_button = $('<button></button>')
					.html('Copy')
					.addClass('btn btn-outline-info btn-xs copy_button_class')
					.attr("id", sensor_name_clean)
					.attr('data-copy', html_li)

				var topic_link_ul = $('<ul></ul>');
				var topic_link_li = $('<li></li>')
					.html(html_li + "  " + copy_button.prop('outerHTML'))
					.addClass('font-weight-normal font-italic text-body')

				topic_link_ul.append(topic_link_li);

				topic_head_li.append(topic_link_ul);
				topic_list.append(topic_head_li);
			});

			$(".copy_button_class").on("click", function () {
				var copyText = $(this).attr('data-copy');

				copyTextToClipboard(copyText);
			})
		}

		var device_id = "X";
		function updateDevicesParams(response) {
			$("#loader_main").css("display", "none");
			device_id = response.dev_id;
			list_sensor_topics();
		}

		function noSensorData(response) {
			$("#loader_main").css("display", "none");
			console.log("POST Error...")
		}

		function updateSensorList() {
			sensor_list = g_modbus_drivers.template_header.responseParser;
		}

		//********* Call all start up functions after this line *******//
		// updateConfigFromFS(load_form_data);
		getDeviceParams(updateDevicesParams, noSensorData);
		getLocalModbusDrivers(updateSensorList);
	});
</script>